DECLARE
    sequencia NUMBER(15, 0);
BEGIN
    FOR r IN (
        SELECT
            confrestricaocanalventa_id,
            tipoptovta_id,
            origen_id,
            destino_id,
            tempopermitir,
            segunda,
            terca,
            quarta,
            quinta,
            sexta,
            sabado,
            domingo,
            usuario_id,
            activo,
            fecmodif
        FROM
            conf_restricao_canalventa
        WHERE
            fecfinvigencia >= SYSDATE
            AND activo = 1
    ) LOOP
        sequencia := conf_restricao_tramo_seq.nextval;
        INSERT INTO conf_restricao_tramo (
            confrestricaotramo_id,
            confrestricaocanalventa_id,
            tipoptovta_id,
            origen_id,
            destino_id,
            tempopermitir,
            segunda,
            terca,
            quarta,
            quinta,
            sexta,
            sabado,
            domingo,
            usuario_id,
            activo,
            fecmodif
        ) VALUES (
            sequencia,
            r.confrestricaocanalventa_id,
            r.tipoptovta_id,
            r.origen_id,
            r.destino_id,
            r.tempopermitir,
            r.segunda,
            r.terca,
            r.quarta,
            r.quinta,
            r.sexta,
            r.sabado,
            r.domingo,
            r.usuario_id,
            r.activo,
            r.fecmodif
        );

        UPDATE conf_restricao_excecao cre
        SET
            cre.confrestricaotramo_id = sequencia
        WHERE
            cre.confrestricaocanalventa_id = r.confrestricaocanalventa_id;

        UPDATE conf_restricao_ptovta crp
        SET
            crp.confrestricaotramo_id = sequencia
        WHERE
            crp.confrestricaocanalventa_id = r.confrestricaocanalventa_id;

    END LOOP;
END;